package com.example.dto;

import com.example.dto.enumeration.BachelorSemester;
import com.example.dto.enumeration.CourseType;
import com.example.dto.enumeration.ExamType;

public class Course
{
    // most attributes are concrete and can't be changed easily without changing the whole system
    private final int id;   // PK // FK
    private final String name;
    private final BachelorSemester bachelorSemester;
    private final CourseType courseType;
    private final int sws;
    private final double ects;
    private ExamType examType;

    public Course(int id, String name, BachelorSemester bachelorSemester, CourseType courseType, int sws, double ects, ExamType examType)
    {
        this.id = id;
        this.name = name;
        this.bachelorSemester = bachelorSemester;
        this.courseType = courseType;
        this.sws = sws;
        this.ects = ects;
        this.examType = examType;
    }

    public int getId(){
        return id;
    }

    @Override
    public String toString() {
        return "\nCourse: " +
                "id=" + id +
                ", name='" + name + '\'' +
                ", bachelorSemester=" + bachelorSemester +
                ", courseType=" + courseType +
                ", sws=" + sws +
                ", ects=" + ects +
                ", examType=" + examType;
    }
}
