package com.example.gui;

import com.example.dto.Student;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.control.ComboBox;

import javafx.scene.*;
import javafx.scene.Node;
import javafx.stage.*;

import java.io.IOException;
import java.util.ArrayList;

public class MainController {
    @FXML
    protected ComboBox<CoursesOfStudy> coursesOfStudyComboBox;
    @FXML
    public ComboBox<Student> studentComboBox;
    public ObservableList<CoursesOfStudy> coursesOfStudyList = FXCollections.observableArrayList();

    public static ObservableList<Student> studentList = FXCollections.observableArrayList();

    protected void setCoursesOfStudyComboBox() {
        coursesOfStudyComboBox.setItems(coursesOfStudyList);
    }

    protected void setStudentComboBox() {
        studentComboBox.setItems(studentList);
    }

    @FXML
    protected void initialize() {
        if (!coursesOfStudyList.isEmpty()) {
            setCoursesOfStudyComboBox();
        }
        if (!studentList.isEmpty()) {
            setStudentComboBox();
        }
    }


    private Stage stage;
    private Scene scene;
    private FXMLLoader root;

    @FXML
    protected void switchToMain(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("main.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Main");
        stage.setScene(scene);
        stage.show();

    }

    @FXML
    protected void switchToStudentDetails(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("student-details.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Student Details");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToStudentModification(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("student-modification.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Student Modification");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToDegreeDetails(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("degree-details.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Degree Details");
        stage.setScene(scene);
        stage.show();
    }

    @FXML
    protected void switchToCoursesOfStudyModification(ActionEvent event) throws IOException {
        root = new FXMLLoader(Main.class.getResource("courses-of-study-modification.fxml"));
        stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        scene = new Scene(root.load(), 960, 540);
        stage.setTitle("Courses Of Study Modification");
        stage.setScene(scene);
        stage.show();
    }
}
